#include "main.h"

void record_to_base(const PWLX_NOTIFICATION_INFO info, int action, int action_descr)
{    
    QFile logger("c:\\persspy.log");
    logger.open(QIODevice::Append | QIODevice::WriteOnly | QIODevice::Text);    
    QSqlDatabase db;    

    {
    QTextCodec::setCodecForCStrings(QTextCodec::codecForName("UTF-8"));
    QTextCodec::setCodecForLocale(QTextCodec::codecForName("UTF-8"));
    QTextCodec::setCodecForTr(QTextCodec::codecForName("UTF-8"));

    QCoreApplication::addLibraryPath("c:\\WINDOWS\\system32\\sqldrivers\\");
    QCoreApplication::addLibraryPath(QCoreApplication::applicationDirPath()+"./");

    QSettings *settings = new QSettings("HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\Winlogon\\Notify\\PersSpy",
                               QSettings::NativeFormat);

    db.addDatabase("QMYSQL", "ARM");

    logger.write("Open database\n");
    db.setHostName( settings->value("host", "localhost").toString() );
    logger.write(settings->value("host", "localhost").toString().toLocal8Bit());

    db.setPort( settings->value("port", "3306").toInt() );    
    logger.write(settings->value("port", "3306").toString().toLocal8Bit());

    db.setUserName( settings->value("username", "root").toString() );
    logger.write(settings->value("username", "root").toString().toLocal8Bit());

    db.setPassword( settings->value("password", "" ).toString() );
    logger.write(settings->value("password", "").toString().toLocal8Bit());

    db.setDatabaseName(settings->value("database", "ARM").toString());
    logger.write(settings->value("database", "ARM").toString().toLocal8Bit());

    if (!db.open()) {
            logger.write( QString("Error " + db.lastError().text() + db.databaseName() + db.userName() + db.password()).toLocal8Bit() );
            logger.write("Drivers:\n");
            for (int i=0; i < db.drivers().count() ; i++)
            {
                logger.write(QString(db.drivers().at(i) ).toLocal8Bit());
            }
            logger.write("AppLibPath:\n");
            for (int i=0; i < QCoreApplication::libraryPaths().count() ; i++)
            {
                logger.write(QString(QCoreApplication::libraryPaths().at(i)).toLocal8Bit());
            }
        }
    }
    QString user;
    user.fromStdWString(info->UserName);
    logger.write(user.toLocal8Bit());    

    QString host;
    host.fromStdWString(info->Domain );
    if (host.isEmpty())
    {
        host.fromStdWString( info->WindowStation );
    }
    logger.write(host.toLocal8Bit());
    // Отправка времени входа пользователя
    QSqlQuery query(db);
    query.prepare("INSERT INTO `journal` (time, action, action_descr, users_id) "
                  "VALUES (:time, :action, :action_descr, :users_id)");
    query.bindValue(":time", QDateTime::currentDateTime());
    query.bindValue(":action", action);
    query.bindValue(":action_descr", action_descr);
    query.bindValue(":users_id", "\\\\"+host+"\\"+user);
    if (!query.exec())
    {
        logger.write(query.lastError().text().toLocal8Bit());
    }
    logger.write(query.lastQuery().toLocal8Bit());

    query.finish();
    db.close();
    logger.write("end\n");
}

void WLEventLogon(const PWLX_NOTIFICATION_INFO info)
{       
 record_to_base(info, 02, 01);
}

void WLEventLogoff(const PWLX_NOTIFICATION_INFO info)
{
record_to_base(info, 02, 02);
}

void WLEventStartup(const PWLX_NOTIFICATION_INFO info)
{
record_to_base(info, 01, 01);
}

void WLEventShutdown(const PWLX_NOTIFICATION_INFO info)
{
record_to_base(info, 01, 02);
}

void WLEventStartScreenSaver(const PWLX_NOTIFICATION_INFO info)
{
record_to_base(info, 04, 01);
}

void WLEventStopScreenSaver(const PWLX_NOTIFICATION_INFO info)
{
record_to_base(info, 02, 02);
}

void WLEventLock(const PWLX_NOTIFICATION_INFO info)
{
record_to_base(info, 05, 01);
}

void WLEventUnlock(const PWLX_NOTIFICATION_INFO info)
{
record_to_base(info, 05, 02);
}

