#ifndef MAIN_H
#define MAIN_H

#ifdef D_SHARED_LIB
        #define D_SHARED Q_DECL_EXPORT
#else
        #define D_SHARED Q_DECL_IMPORT
#endif

#include "QTextCodec"
#include <QtCore/QCoreApplication>
#include <QFile>
#include <QString>
#include <QStringList>
#include <QProcess>
#include <QDebug>
#include <QObject>
#include "QSqlDatabase"
#include "QSqlDriver"
#include "QSqlQuery"
#include "QSqlError"
#include "QSettings"
#include "QDateTime"
#include <QLibrary>
#include <wtypes.h>

#ifdef UNICODE
#define QStringToTCHAR(x)     (wchar_t*) x.utf16()
#define PQStringToTCHAR(x)    (wchar_t*) x->utf16()
#define TCHARToQString(x)     QString::fromUtf16((x))
#define TCHARToQStringN(x,y)  QString::fromUtf16((x),(y))
#else
#define QStringToTCHAR(x)     x.local8Bit().constData()
#define PQStringToTCHAR(x)    x->local8Bit().constData()
#define TCHARToQString(x)     QString::fromLocal8Bit((x))
#define TCHARToQStringN(x,y)  QString::fromLocal8Bit((x),(y))
#endif

typedef DWORD (*PFNMSGECALLBACK) (BOOL bVerbose, LPWSTR lpMessage);

typedef struct _WLX_NOTIFICATION_INFO
{
  ULONG  Size ;
  ULONG  Flags ;
  PWSTR  UserName ;
  PWSTR  Domain ;
  PWSTR  WindowStation ;
  HANDLE hToken ;
  HDESK  hDesktop ;
  PFNMSGECALLBACK pStatusCallback; // PFNMSGECALLBACK
} WLX_NOTIFICATION_INFO, * PWLX_NOTIFICATION_INFO ;

extern "C" {
    void WLEventLogon(const PWLX_NOTIFICATION_INFO info);
    void WLEventLogoff(const PWLX_NOTIFICATION_INFO info);
    void WLEventStartup(const PWLX_NOTIFICATION_INFO info);
    void WLEventShutdown(const PWLX_NOTIFICATION_INFO info);
    void WLEventStartScreenSaver(const PWLX_NOTIFICATION_INFO info);
    void WLEventStopScreenSaver(const PWLX_NOTIFICATION_INFO info);
    void WLEventLock(const PWLX_NOTIFICATION_INFO info);
    void WLEventUnlock(const PWLX_NOTIFICATION_INFO info);
}

#endif // MAIN_H
